/** Request 网络请求工具 更详细的 api 文档: https://github.com/umijs/umi-request */
import { extend } from 'umi-request';

import { notification } from 'antd';

import Cookies from 'js-cookie';
import moment from 'moment';
import session from './session';
import type { CurrentUser } from '@/models/user';

const codeMessage: Record<number, string> = {
  200: '服务器成功返回请求的数据。',
  201: '新建或修改数据成功。',
  202: '一个请求已经进入后台排队（异步任务）。',
  204: '删除数据成功。',
  400: '发出的请求有错误，服务器没有进行新建或修改数据的操作。',
  401: '用户没有权限（令牌、用户名、密码错误）。',
  403: '用户得到授权，但是访问是被禁止的。',
  404: '发出的请求针对的是不存在的记录，服务器没有进行操作。',
  406: '请求的格式不可得。',
  410: '请求的资源被永久删除，且不会再得到的。',
  422: '当创建一个对象时，发生一个验证错误。',
  500: '服务器发生错误，请检查服务器。',
  502: '网关错误。',
  503: '服务不可用，服务器暂时过载或维护。',
  504: '网关超时。',
};

/**
 * @zh-CN 异常处理程序
 * @en-US Exception handler
 */
const errorHandler = (error: { response: Response }): Response => {
  const { response } = error;

  if (response && response.status) {
    const errorText = codeMessage[response.status] || response.statusText;
    const { status, url } = response;

    notification.error({
      message: `请求错误 ${status}: ${url}`,
      description: errorText,
    });
  } else if (!response) {
    notification.error({
      description: '您的网络异常，无法连接到服务器.',
      message: '网络异常',
    });
  }
  return response;
};

/**
 * @en-US Configure the default parameters for request
 * @zh-CN 配置request请求时的默认参数
 */
const requestTest = extend({
  errorHandler, // default error handling
  // prefix: '/EShangApiMain',//  开发
  prefix: 'http://dev.eshangtech.com:8900/EShangApiMain', // 正式
  headers: {
    token: '',
    ProvinceCode: '',
    ServerpartCodes: '',
    // tmp: (new Date()).getTime()
  }

  // credentials: 'include', // Does the default request bring cookies

});

// request拦截器, 改变url 或 options.
requestTest.interceptors.request.use((url, opt) => {
  const options = { ...opt }
  const currentUser: CurrentUser = session.get('currentUser');
  if (currentUser) {
    if (options.headers) {
      options.headers = {
        ...options.headers,
        token: currentUser.UserToken || '',
        ProvinceCode: currentUser.ProvinceCode || '',
        ServerpartCodes: currentUser.CityAuthority || '',
        ServerpartShopIds: currentUser.ServerpartShopIds || '',
        UserPattern: currentUser?.UserPattern || '',
      }
    }
    if ((url.indexOf('Synchro') > -1 || url.indexOf('Save') > -1) &&
      url.indexOf('Picture/SaveImgFile') === -1) {
      // 添加操作人和业主单位信息
      options.data = {
        ...options.data,
        STAFF_ID: currentUser.ID,
        STAFF_NAME: currentUser.Name,
        OWNERUNIT_ID: currentUser.OwnerUnitId,
        OWNERUNIT_NAME: currentUser.ProvinceUnit,
        PROVINCE_CODE: currentUser.ProvinceCode,

        OPERATE_DATE: moment().format()
      }
      if (currentUser?.UserPattern === 2000) {
        options.data = {
          ...options.data,
          BUSINESSMAN_ID: currentUser.BusinessManID,
        }
      }
    }
  }
  return {
    // url: url.indexOf('handler_ajax.ashx')>-1 ?`https://user.eshangtech.com${url}`: `http://47.96.233.105/EShangApiMain${url}`,
    url,// .indexOf('handler_ajax.ashx')>-1 ?`${url}`: `/EShangApiMain${url}`,
    options,
  }
})
requestTest.interceptors.response.use((response) => {

  const nowTmp = moment()
  Cookies.set('tmp', nowTmp.format())
  return response
})
export default requestTest;
